/**
 *
 *
 * Rename "main.default.js" to "main.js" and edit it if you need configure elFInder options or any things. And use that in elfinder.html.
 * e.g. `<script data-main="./main.js" src="./require.js"></script>`
 **/
(function(){
	"use strict";
	var // jQuery and jQueryUI version
		jqver = '3.6.0',
		uiver = '1.12.1',
		
		// Detect language (optional)
		lang = (function() {
			var locq = window.location.search,
				map = {
					'pt' : 'pt_BR',
					'ug' : 'ug_CN',
					'zh' : 'zh_CN'
				},
				full = {
					'zh_tw' : 'zh_TW',
					'zh_cn' : 'zh_CN',
					'fr_ca' : 'fr_CA'
				},
				fullLang, locm, lang;
			if (locq && (locm = locq.match(/lang=([a-zA-Z_-]+)/))) {
				// detection by url query (?lang=xx)
				fullLang = locm[1];
			} else {
				// detection by browser language
				fullLang = (navigator.browserLanguage || navigator.language || navigator.userLanguage || '');
			}
			fullLang = fullLang.replace('-', '_').substr(0,5).toLowerCase();
			if (full[fullLang]) {
				lang = full[fullLang];
			} else {
				lang = (fullLang || 'en').substr(0,2);
				if (map[lang]) {
					lang = map[lang];
				}
			}
			return lang;
		})(),
		
		// Start elFinder (REQUIRED)
		start = function(elFinder, editors, config) {
			// load jQueryUI CSS
			//elFinder.prototype.loadCss('//cdnjs.cloudflare.com/ajax/libs/jqueryui/'+uiver+'/themes/smoothness/jquery-ui.css');
			elFinder.prototype.loadCss('./cdn/jquery-ui-themes-1.12.1/themes/smoothness/jquery-ui.min.css');

			$(function() {
				var optEditors = {
						commandsOptions: {
							edit: {
								editors: Array.isArray(editors)? editors : []
							}
						}
					},
					opts = {};
				
				// Interpretation of "elFinderConfig"
				if (config && config.managers) {
					$.each(config.managers, function(id, mOpts) {
						opts = Object.assign(opts, config.defaultOpts || {});
						// editors marges to opts.commandOptions.edit
						try {
							mOpts.commandsOptions.edit.editors = mOpts.commandsOptions.edit.editors.concat(editors || []);
						} catch(e) {
							Object.assign(mOpts, optEditors);
						}
						// Make elFinder
						$('#' + id).elfinder(
							// 1st Arg - options
							$.extend(true, { lang: lang }, opts, mOpts || {}),
							// 2nd Arg - before boot up function
							function(fm, extraObj) {
								// `init` event callback function
								fm.bind('init', function() {
									// Optional for Japanese decoder "encoding-japanese"
									if (fm.lang === 'ja') {
										require(
											[ 'encoding-japanese' ],
											function(Encoding) {
												if (Encoding && Encoding.convert) {
													fm.registRawStringDecoder(function(s) {
														return Encoding.convert(s, {to:'UNICODE',type:'string'});
													});
												}
											}
										);
									}
								});
							}
						);
					});
				} else {
					alert('"elFinderConfig" object is wrong.');
				}
			});
		},
		
		// JavaScript loader (REQUIRED)
		load = function() {
			require(
				[
					'elfinder'
					, 'extras/editors.default.min'               // load text, image editors
					, 'elFinderConfig'
				//	, 'extras/quicklook.googledocs.min'          // optional preview for GoogleApps contents on the GoogleDrive volume
				],
				start,
				function(error) {
					alert(error.message);
				}
			);
		},
		
		// is IE8 or :? for determine the jQuery version to use (optional)
		old = (typeof window.addEventListener === 'undefined' && typeof document.getElementsByClassName === 'undefined')
		       ||
		      (!window.chrome && !document.unqueID && !window.opera && !window.sidebar && 'WebkitAppearance' in document.documentElement.style && document.body.style && typeof document.body.style.webkitFilter === 'undefined');

	// config of RequireJS (REQUIRED)
	require.config({
		baseUrl : 'js',
		paths : {
			//'jquery'   : '//cdnjs.cloudflare.com/ajax/libs/jquery/'+(old? '1.12.4' : jqver)+'/jquery.min',
			//'jquery-ui': '//cdnjs.cloudflare.com/ajax/libs/jqueryui/'+uiver+'/jquery-ui.min',
            'jquery'   : old? 'jquery-1.12.4.min' : 'jquery-3.6.0.min',
            'jquery-ui': 'jquery-ui-1.12.1/jquery-ui.min',
			'elfinder' : 'elfinder.min',
			//'encoding-japanese': '//cdn.rawgit.com/polygonplanet/encoding.js/1.0.26/encoding.min'
			'encoding-japanese': 'encoding.min'
		},
		waitSeconds : 10 // optional
	});

	// check elFinderConfig and fallback
	// This part don't used if you are using elfinder.html, see elfinder.html
	if (! require.defined('elFinderConfig')) {
		define('elFinderConfig', {
			// elFinder options (REQUIRED)
			// Documentation for client options:
			// https://github.com/Studio-42/elFinder/wiki/Client-configuration-options
			defaultOpts : {
				url : '/f.jsp' // connector URL (REQUIRED)
				,showFiles : 512
				//urlUpload
				,commandsOptions : {
					edit : {
						extraOptions : {
							// set API key to enable Creative Cloud image editor
							// see https://console.adobe.io/
							creativeCloudApiKey : '',
							// browsing manager URL for CKEditor, TinyMCE
							// uses self location with the empty value
							managerUrl : ''
						}
					}
					,quicklook : {
						// to enable CAD-Files and 3D-Models preview with sharecad.org
						sharecadMimes : [],
						// to enable preview with Google Docs Viewer
						googleDocsMimes : [],
						// to enable preview with Microsoft Office Online Viewer
						// these MIME types override "googleDocsMimes"
						officeOnlineMimes : []
					}
					,help : { view : ['shortcuts', 'help'] }
				}
				,ui : ['toolbar', 'tree', 'path', 'stat']
				,uiOptions : {
                 		// toolbar configuration
                 		toolbar : [
                 			['home', 'back', 'forward', 'up', 'reload'],
                 			['netmount'],
                 			['mkdir', 'mkfile', 'upload'],
                 			['open', 'download', 'getfile'],
                 			['undo', 'redo'],
                 			['copy', 'cut', 'paste', 'rm', 'empty'],
                 			['duplicate', 'rename', 'edit', 'resize', 'chmod'],
                 			['selectall', 'selectnone', 'selectinvert'],
                 			['quicklook', 'info'],
                 			['extract', 'archive'],
                 			['search'],
                 			['view', 'sort'],
                 			['preference', 'help'],
                 			['fullscreen']
                 		],
                 		// toolbar extra options
                 		toolbarExtra : {
                 			// also displays the text label on the button (true / false)
                 			displayTextLabel: false,
                 			// Exclude `displayTextLabel` setting UA type
                 			labelExcludeUA: ['Mobile'],
                 			// auto hide on initial open
                 			autoHideUA: [],
                 			// Initial setting value of hide button in toolbar setting
                 			defaultHides: ['hide'],
                 			// show Preference button ('none', 'auto', 'always')
                 			// If you do not include 'preference' in the context menu you should specify 'auto' or 'always'
                 			showPreferenceButton: 'none'
                 		},
                 		// directories tree options
                 		tree : {
                 			// expand current root on init
                 			openRootOnLoad : true,
                 			// expand current work directory on open
                 			openCwdOnOpen  : true,
                 			// auto loading current directory parents and do expand their node.
                 			syncTree : true,
                 			// Maximum number of display of each child trees
                 			// The tree of directories with children exceeding this number will be split
                 			subTreeMax : 100,
                 			// Numbar of max connctions of subdirs request
                 			subdirsMaxConn : 2,
                 			// Number of max simultaneous processing directory of subdirs
                 			subdirsAtOnce : 5,
                 			// Durations of each animations
                 			durations : {
                 				slideUpDown : 'fast',
                 				autoScroll : 'fast'
                 			}
                 			// ,
                 			// /**
                 			//  * Add CSS class name to navbar directories (optional)
                 			//  * see: https://github.com/Studio-42/elFinder/pull/1061,
                 			//  *      https://github.com/Studio-42/elFinder/issues/1231
                 			//  *
                 			//  * @type Function
                 			//  */
                 			// getClass: function(dir) {
                 			// 	// e.g. This adds the directory's name (lowercase) with prefix as a CSS class
                 			// 	return 'elfinder-tree-' + dir.name.replace(/[ "]/g, '').toLowerCase();
                 			// }
                 		},
                 		// navbar options
                 		navbar : {
                 			minWidth : 150,
                 			maxWidth : 500,
                 			// auto hide on initial open
                 			autoHideUA: ['Mobile'] // e.g. ['Mobile']
                 		},
                 		navdock : {
                 			// disabled navdock ui
                 			disabled : false,
                 			// percentage of initial maximum height to work zone
                 			initMaxHeight : '50%',
                 			// percentage of maximum height to work zone by user resize action
                 			maxHeight : '90%'
                 		},
                 		cwd : {
                 			// display parent folder with ".." name :)
                 			oldSchool : false,

                 			// fm.UA types array to show item select checkboxes e.g. ['All'] or ['Mobile'] etc. default: ['Touch']
                 			showSelectCheckboxUA : ['Touch'],

                 			// file info columns displayed
                 			listView : {
                 				// name is always displayed, cols are ordered
                 				// e.g. ['perm', 'date', 'size', 'kind', 'owner', 'group', 'mode']
                 				// mode: 'mode'(by `fileModeStyle` setting), 'modestr'(rwxr-xr-x) , 'modeoct'(755), 'modeboth'(rwxr-xr-x (755))
                 				// 'owner', 'group' and 'mode', It's necessary set volume driver option "statOwner" to `true`
                 				// for custom, characters that can be used in the name is `a-z0-9_`
                 				columns : ['perm', 'date', 'size', 'kind'],
                 				// override this if you want custom columns name
                 				// example
                 				// columnsCustomName : {
                 				//		date : 'Last modification',
                 				// 		kind : 'Mime type'
                 				// }
                 				columnsCustomName : {},
                 				// fixed list header colmun
                 				fixedHeader : true
                 			},

                 			// icons view setting
                 			iconsView : {
                 				// default icon size (0-3 in default CSS (cwd.css - elfinder-cwd-size[number]))
                 				size: 0,
                 				// number of maximum size (3 in default CSS (cwd.css - elfinder-cwd-size[number]))
                 				// uses in preference.js
                 				sizeMax: 3,
                 				// Name of each size
                 				sizeNames: {
                 					0: 'viewSmall',
                 					1: 'viewMedium',
                 					2: 'viewLarge',
                 					3: 'viewExtraLarge'
                 				}
                 			},

                 			// /**
                 			//  * Add CSS class name to cwd directories (optional)
                 			//  * see: https://github.com/Studio-42/elFinder/pull/1061,
                 			//  *      https://github.com/Studio-42/elFinder/issues/1231
                 			//  *
                 			//  * @type Function
                 			//  */
                 			// ,
                 			// getClass: function(file) {
                 			// 	// e.g. This adds the directory's name (lowercase) with prefix as a CSS class
                 			// 	return 'elfinder-cwd-' + file.name.replace(/[ "]/g, '').toLowerCase();
                 			//}

                 			//,
                 			//// Template placeholders replacement rules for overwrite. see ui/cwd.js replacement
                 			//replacement : {
                 			//	tooltip : function(f, fm) {
                 			//		var list = fm.viewType == 'list', // current view type
                 			//			query = fm.searchStatus.state == 2, // is in search results
                 			//			title = fm.formatDate(f) + (f.size > 0 ? ' ('+fm.formatSize(f.size)+')' : ''),
                 			//			info  = '';
                 			//		if (query && f.path) {
                 			//			info = fm.escape(f.path.replace(/\/[^\/]*$/, ''));
                 			//		} else {
                 			//			info = f.tooltip? fm.escape(f.tooltip).replace(/\r/g, '&#13;') : '';
                 			//		}
                 			//		if (list) {
                 			//			info += (info? '&#13;' : '') + fm.escape(f.name);
                 			//		}
                 			//		return info? info + '&#13;' + title : title;
                 			//	}
                 			//}
                 		},
                 		path : {
                 			// Move to head of work zone without UI navbar
                 			toWorkzoneWithoutNavbar : true
                 		},
                 		dialog : {
                 			// Enable to auto focusing on mouse over in the target form element
                 			focusOnMouseOver : true
                 		},
                 		toast : {
                 			animate : {
                 				// to show
                 				showMethod: 'fadeIn', // fadeIn, slideDown, and show are built into jQuery
                 				showDuration: 300,    // milliseconds
                 				showEasing: 'swing',  // swing and linear are built into jQuery
                 				// timeout to hide
                 				timeOut: 3000,
                 				// to hide
                 				hideMethod: 'fadeOut',
                 				hideDuration: 1500,
                 				hideEasing: 'swing'
                 			}
                 		}
                }
                ,bootCallback : function(fm, extraObj) {
                						/* any bind functions etc. */
                						fm.bind('init', function() {
                							// any your code
                						});
                						// for example set document.title dynamically.
                						var title = document.title;
                						fm.bind('open', function() {
                							var path = '',
                								cwd  = fm.cwd();
                							if (cwd) {
                								path = fm.path(cwd.hash) || null;
                							}
                							document.title = path? path + ':' + title : title;
                						}).bind('destroy', function() {
                							document.title = title;
                						});
                					}
				,height : '100%' // you can use '100%' to fit window height
				,resizable: false
				,requestType : 'post'
			},
			managers : {
				'elfinder': {},
			}
		});
	}

	// load JavaScripts (REQUIRED)
	load();

})();
